/*
 * Main author(s) : Jean-Noël Monette
 * 
 * Copyright (c) 2013, Jean-Noël Monette
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package convexPairs.inoscar;

import convexPairs.Parameters;

public abstract class ParametersWithOscar implements Parameters{

	private Parameters f;

	public abstract void updateDomains();
	public abstract void enforceGLessThanOrEqual(int i, int v);
	public abstract void enforceGGreaterThanOrEqual(int i, int v);
	public abstract void enforceIfGEqualThenFLessThanOrEqual(int i, int v, int u);
	
	public void setFunction(Parameters f){this.f = f;}
	
	public boolean useGeneralCase(int i) {
		return f.useGeneralCase(i);
	}
	public int getN() {
		return f.getN();
	}
	public int evaluateF(int i, int x) {
		return f.evaluateF(i, x);
	}
	public int evaluateG(int i, int x) {
		return f.evaluateG(i, x);
	}
	public int getArgminF(int i) {
		return f.getArgminF(i);
	}
	public int getDeltaP(int i, int v0) {
		return f.getDeltaP(i, v0);
	}
	public int getBPP(int i, int v0) {
		return f.getBPP(i, v0);
	}
	public int getDeltaN(int i, int v0) {
		return f.getDeltaN(i, v0);
	}
	public int getBPN(int i, int v0) {
		return f.getBPN(i, v0);
	}
	
}
