/*
 * Main author(s) : Jean-Noël Monette
 * 
 * Copyright (c) 2013, Jean-Noël Monette
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package convexPairs.inoscar.tests

import oscar.cp.modeling._
import oscar.cp.core._
import convexPairs.inoscar.modeling.Constraints

object MyModel extends App with Constraints {
	 //def main(args: Array[String]) {
     
      def testOrig(n:Int){
      		
      	val cp = CPSolver(); 
      	val nd = CPVarInt(cp,0 to n*2);
      	val rng = 0 until n;
      	//println("\nbef"+System.currentTimeMillis());
      	val x = for(i <- rng) yield CPVarInt(cp,-100 to 100);
      	//println("aft"+System.currentTimeMillis());
        //cp.add(deviationMy(x, 0, nd ))
      	val t1 = System.currentTimeMillis();
        cp.add(deviation(x, 1, nd ));
        val t2 = System.currentTimeMillis();
//        println(x.mkString(","));
//        println(nd);
        print("orig: "+(t2-t1)+"\t");
      	}
      
      def testNew(n:Int){	
      	val cp = CPSolver(); 
      	val nd = CPVarInt(cp,0 to n*2);
      	val rng = 0 until n;
      	//println("\nbef"+System.currentTimeMillis());
      	val x = for(i <- rng) yield CPVarInt(cp,-100 to 100);
      	//println("aft"+System.currentTimeMillis());
      	val t1 = System.currentTimeMillis();
      	//println("t1"+t1);
        cp.add(deviation2(x, -1, nd ))
      	val t2 = System.currentTimeMillis();
        //cp.add(deviation(x, 0, nd ));
        println(x.mkString(";"));
//        println(nd);
        print("new: "+(t2-t1)+"\t");
      	}
      	
      var i=10;
      while(i<11){
      	print(i+"\t");
    	  testOrig(i);
    	  testNew(i);
    	  i=i+1000;
    	  println();
      }
}